
%code provides {

#include <iostream>
#include <map>
using namespace std;

#define YY_DECL yy::parser::token_type yylex(int *yylval)

YY_DECL;

} 

%{
#include <map>
using namespace std;
int contador=0;
map<int, int> datos;
%}

%defines // ahorramos el -d al llamar a bison

%token END 0 "end of file"

%token num plus times lpar rpar elevado var igual

%%

S : E { std::cout << "Resultado: "<< $1 << std::endl;}

E : num	{contador=contador+1;}
  | E plus  E { $$ = $1 + $3; contador=contador+1;}
  | E times E { $$ = $1 * $3; contador=contador+1;}
  | E elevado E { $$ = $1; while($3 > 1){$$ = $$ * $1; $3 = $3 - 1;} contador=contador+1;}
  | lpar E rpar { $$ = $2; contador=contador+1;}
  | E igual var { $$ = $1; contador=contador+1; printf("Ascii: %d", $3); datos[$3] = $1;}
  | var igual E { $$ = $3; contador=contador+1; datos[$1] = $3;}
  | var {contador=contador+1; $$ = datos[$1];}
  ;

%%

using namespace yy;

void parser::error (const location_type& loc, const std::string& msg){
  std::cerr << msg << std::endl;
  printf("Falla en el caracter: %d",contador);
  exit(1);
}

int main() { 
  parser p;
  while(1){
  	p.parse(); 
  }
}
